<template>
  <div class="tab" :class="{ pageSet }" ref="el">
    <slot/>
  </div>
</template>

<script>
export default {
  data: () => ({
    pageSet: true,

    _el: null,
  }),
  props: {
    page: {
      type: String,
      required: true,
    },
  },
  watch: {
    tabPageName() {
      this.onChildrenEvent();
    },
  },
  computed: {
    tabPageName() {
      return `tab-page-${this.$props.page}`;
    },
  },
  methods: {
    onChildrenEvent() {
      this._el.children.forEach(el => {
        if (el.hasAttribute('data-page')) {
          if (el.dataset.page !== this.tabPageName)
            el.classList.remove('show');
          else
            el.classList.add('show');
        }
      });
    },
  },
  mounted() {
    this._el = this.$refs.el;
    let ob = new MutationObserver(this.onChildrenEvent);

    ob.observe(this._el, { childList: true });
    this.onChildrenEvent();
  },
};
</script>

<style scoped>
.tab {
  overflow: hidden;
}

.tab > *[data-page]:not(.show) {
  display: none !important;
}
</style>
